if (!defined &_SYS_PROC_H_) {
    eval 'sub _SYS_PROC_H_ {1;}';
    require 'machine/proc.ph';
    require 'sys/rtprio.ph';
    require 'sys/select.ph';
    require 'sys/time.ph';
    require 'sys/queue.ph';
    require 'sys/param.ph';
    eval 'sub p_ucred {defined &p_cred && &p_cred->defined &pc_ucred && &pc_ucred;}';
    eval 'sub p_rlimit {defined &p_limit && &p_limit->defined &pl_rlimit && &pl_rlimit;}';
    eval 'sub p_startzero {defined &p_oppid && &p_oppid;}';
    eval 'sub p_endzero {defined &p_hash && &p_hash.defined &le_next && &le_next;}';
    eval 'sub p_startcopy {defined &p_sigmask && &p_sigmask;}';
    eval 'sub p_endcopy {defined &p_addr && &p_addr;}';
    eval 'sub p_session {defined &p_pgrp && &p_pgrp->defined &pg_session && &pg_session;}';
    eval 'sub p_pgid {defined &p_pgrp && &p_pgrp->defined &pg_id && &pg_id;}';
    eval 'sub SIDL {1;}';
    eval 'sub SRUN {2;}';
    eval 'sub SSLEEP {3;}';
    eval 'sub SSTOP {4;}';
    eval 'sub SZOMB {5;}';
    eval 'sub P_ADVLOCK {0x00001;}';
    eval 'sub P_CONTROLT {0x00002;}';
    eval 'sub P_INMEM {0x00004;}';
    eval 'sub P_NOCLDSTOP {0x00008;}';
    eval 'sub P_PPWAIT {0x00010;}';
    eval 'sub P_PROFIL {0x00020;}';
    eval 'sub P_SELECT {0x00040;}';
    eval 'sub P_SINTR {0x00080;}';
    eval 'sub P_SUGID {0x00100;}';
    eval 'sub P_SYSTEM {0x00200;}';
    eval 'sub P_TIMEOUT {0x00400;}';
    eval 'sub P_TRACED {0x00800;}';
    eval 'sub P_WAITED {0x01000;}';
    eval 'sub P_WEXIT {0x02000;}';
    eval 'sub P_EXEC {0x04000;}';
    eval 'sub P_NOSWAP {0x08000;}';
    eval 'sub P_PHYSIO {0x10000;}';
    eval 'sub P_OWEUPC {0x20000;}';
    eval 'sub P_SWAPPING {0x40000;}';
    eval 'sub P_SWAPINREQ {0x80000;}';
    if (defined &KERNEL) {
	eval 'sub PID_MAX {30000;}';
	eval 'sub NO_PID {30001;}';
	eval 'sub SESS_LEADER {
	    local($p) = @_;
	    eval "(($p)->defined &p_session && &p_session->defined &s_leader && &s_leader == ($p))";
	}';
	eval 'sub SESSHOLD {
	    local($s) = @_;
	    eval "(($s)->defined &s_count && &s_count++)";
	}';
	eval 'sub SESSRELE {
	    local($s) = @_;
	    eval "{ defined &if && &if (--($s)->defined &s_count && &s_count == 0)  &FREE($s, defined &M_SESSION && &M_SESSION); }";
	}';
	eval 'sub PHOLD {
	    local($p) = @_;
	    eval "{ defined &if && &if (($p)->defined &p_lock && &p_lock++ == 0 && (($p)->defined &p_flag && &p_flag & defined &P_INMEM && &P_INMEM) == 0)  &faultin($p); }";
	}';
	eval 'sub PRELE {
	    local($p) = @_;
	    eval "(--($p)->defined &p_lock && &p_lock)";
	}';
	eval 'sub PIDHASH {
	    local($pid) = @_;
	    eval "(&defined &pidhashtbl && &pidhashtbl[($pid) & defined &pidhash && &pidhash])";
	}';
	eval 'sub PGRPHASH {
	    local($pgid) = @_;
	    eval "(&defined &pgrphashtbl && &pgrphashtbl[($pgid) & defined &pgrphash && &pgrphash])";
	}';
	eval 'sub NQS {32;}';
    }
}
1;
